//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_BUY2   3
#define SIGNAL_SELL2  4
#define SIGNAL_CLOSEBUY 5
#define SIGNAL_CLOSESELL 6

#property copyright "Expert Advisor Builder"
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"

#include <TradeContext.mq4>



extern int MagicNumber = 1742;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern double Lots = 0.01;
extern int Slippage = 9;
extern bool UseStopLoss = True;
extern double SLX = 2;
extern bool UseTakeProfit = True;
extern double TPX = 4;
extern bool UseTrailingStop = True;
extern double TSX = 6;
extern bool RiskManagement=True;
extern double RiskPercent=1;

int BarCount;
int Current;
double TrailingStop;
bool TickCheck = False;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   CommentMe();
   _IsTradeAllowed();



 
      //risk management
   
   bool MM=RiskManagement;
   if(MM){if(RiskPercent<0.1||RiskPercent>100){Comment("Invalid Risk Value.");return(0);}
   else{Lots=MathFloor((AccountFreeMargin()*AccountLeverage()*RiskPercent*Point*100)/(Ask*MarketInfo(Symbol(),MODE_LOTSIZE)*
   MarketInfo(Symbol(),MODE_MINLOT)))*MarketInfo(Symbol(),MODE_MINLOT);}}
   if(MM==false){Lots=Lots;}



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
   

  
   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+
double high = iHigh(NULL,0,1);
double low = iLow(NULL,0,1);
double close = iClose(NULL,0,1);
double open = iOpen(NULL,0,1);
double P = (high+low+close+open)/4;
double TakeProfit = (high-low)/TPX;
double StopLoss = (high-low)*SLX;
double TrailingStop = (high-low)/TSX;


double Buy1_1 = Bid;
double Buy1_2 = P;

double Sell1_1 = Ask;
double Sell1_2 = P;

double CloseBuy1_5 = Ask;
double CloseBuy1_6 = iLow(NULL, 0, Current + 0);

double CloseSell1_5 = Bid;
double CloseSell1_6 = iHigh(NULL, 0, Current + 0);

   
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;
   if(TradeIsBusy() < 0) 
        return(-1); 
    // refresh the market info
    RefreshRates();

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

                  if (CloseBuy1_5 >= CloseBuy1_6) Order = SIGNAL_CLOSESELL;
                  
            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > TrailingStop) {
                  if(OrderStopLoss() < Bid - TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

                     if (CloseSell1_5 < CloseSell1_6) Order = SIGNAL_CLOSEBUY;
  
            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (TrailingStop)) {
                  if((OrderStopLoss() > (Ask + TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   if (Buy1_1 > Buy1_2 ) Order = SIGNAL_BUY;
   if (Sell1_1 <= Sell1_2) Order = SIGNAL_SELL;




   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }


         if (UseStopLoss) StopLossLevel = Ask - StopLoss ; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid + TakeProfit; else TakeProfitLevel = 0.0;
 
         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue < 0);
            }
            else
            {
         if (UseStopLoss) StopLossLevel = Ask - StopLoss; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid + TakeProfit; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue < 0);
         
         if(Ticket < 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());

             TradeIsNotBusy();

			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
          }
        }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }


         if (UseStopLoss) StopLossLevel = Bid + StopLoss; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask - TakeProfit; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink < 0);
         }
         else
         {
         
         if (UseStopLoss) StopLossLevel = Bid + StopLoss; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask - TakeProfit; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink < 0);
                  
         if(Ticket < 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
				
				
            TradeIsNotBusy();

			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;
   }
  
//----------------------------------------- COMMENT FUNCTION ----------------------------------------------------

int CommentMe()    //Comments out needed parameters on a chart
{
RefreshRates();
double Eq.CM = AccountEquity();
double Bal.CM = AccountBalance();
double Mar.CM = AccountMargin();
double Prof.CM = AccountProfit();
double Lev.CM = AccountLeverage();
double TV.CM = MarketInfo(Symbol(), MODE_TICKVALUE);
double Sprd.CM = MarketInfo(Symbol(), MODE_SPREAD);
double SWL.CM = MarketInfo(Symbol(), MODE_SWAPLONG);
double SWS.CM = MarketInfo(Symbol(), MODE_SWAPSHORT);
double STP.CM = MarketInfo(Symbol(),MODE_STOPLEVEL);
double Odr.CM = OrderOpenPrice();
double High.CM = iHigh(NULL,0,1);
double Low.CM = iLow(NULL,0,1);
double Close.CM = iClose(NULL,0,1);
double Open.CM = iOpen(NULL,0,1);
double MP.CM = (High.CM+Low.CM+Close.CM+Open.CM)/4;
double SLX.CM = (High.CM-Low.CM)*SLX;
double TPX.CM = (High.CM-Low.CM)/TPX;
double TSX.CM = (High.CM-Low.CM)/TSX;



Comment("Account balance is ",DoubleToStr(Bal.CM,2),"\n",
        "Account equity is ",DoubleToStr(Eq.CM,2),"\n",
        "Account profit is ",DoubleToStr(Prof.CM,2),"\n",
        "Account margin is ",DoubleToStr(Mar.CM,2),"\n",
        "Account Leverage is ",DoubleToStr(Lev.CM,2),"\n",        
        "Tick Value is ",DoubleToStr(TV.CM,4),"\n",
        "Spread is ",DoubleToStr(Sprd.CM,0),"\n",
        "Swap Long is ",DoubleToStr(SWL.CM,4),"\n",
        "Swap Short is ",DoubleToStr(SWS.CM,4),"\n",
        "Bar Pivot Point is ",DoubleToStr(MP.CM,4),"\n",
        "Minimum StopLevel is ",DoubleToStr(STP.CM,4),"\n",
        "Order Open Price is ",DoubleToStr(Odr.CM,4),"\n",
        "StopLoss is ",DoubleToStr(SLX.CM,4),"\n", 
        "TakeProfit is ",DoubleToStr(TPX.CM,4),"\n",
        "TrailingStop is ",DoubleToStr(TSX.CM,4),"\n",                                  
        "Current time is ",TimeToStr(TimeCurrent()));
   return(0);
}


//+------------------------------------------------------------------+